<?php

namespace Drupal\ai_interpolator_simple_crawler;

use GuzzleHttp\Client;

/**
 * Guzzle Crawler API.
 */
class Crawler {

  /**
   * The http client.
   */
  protected Client $client;

  /**
   * Constructs a new Crawler object.
   *
   * @param \GuzzleHttp\Client $client
   *   Http client.
   */
  public function __construct(Client $client) {
    $this->client = $client;
  }

  /**
   * Crawl.
   *
   * @param string $url
   *   The url to visit.
   * @param array $parameters
   *   The parameters for the call. q have to be set.
   *
   * @return string
   *   The body response.
   */
  public function request($url, array $parameters) {
    $options['connect_timeout'] = $parameters['connect_timeout'] ?? 5;
    $options['read_timeout'] = $parameters['read_timeout'] ?? 5;
    if (!empty($parameters['user_agent'])) {
      $options['headers']['user-agent'] = $parameters['user_agent'];
    }
    $options['http_errors'] = FALSE;
    $response = $this->client->request('GET', $url, $options);
    if (!empty($parameters['rate_limit_wait'])) {
      usleep($parameters['rate_limit_wait']);
    }
    return $response->getBody();
  }

}
